/*
**********************************************************************************
*  2014 Microchip Technology Inc. and its subsidiaries.
* You may use this software and any derivatives exclusively with
* Microchip products.
* THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS".
* NO WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE,
* INCLUDING ANY IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY,
* AND FITNESS FOR A PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP
* PRODUCTS, COMBINATION WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.
* IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
* INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
* WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
* BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE.
* TO THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL
* CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF
* FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.
* MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE
* OF THESE TERMS.
**********************************************************************************
*  OTP.cpp
*   This file gives the sample code/ test OTP
*
**********************************************************************************
*  $Revision: #1 $  $DateTime: 2014/03/17 18:04:00 $  $    $
*  Description: initial version
**********************************************************************************
* $File:  
*/
#include "stdafx.h"
#include "OTPCmnXdataRamTest.h"

MCHP_USB_ERROR OTPSample()
{
	MCHP_USB_ERROR resut;
	HANDLE hndl = 0; 
	static UCHAR  ucData[64];
	INT ActualBytesRead=0; 
	DEVIO stDEVIO;
	UINT16 Config = 0x8040;
	
	/*
	* 1. Open handle to the connected USB2530 device 
	*/ 
	hndl = MchpUsbOpen (0x0424, 0x2530);
	if(hndl!=NULL){		
		/*
		* 2. Write OTP
		*/ 
		ucData[0] = 0x80;
		ucData[1] = 0x30;
		ucData[2] = 0x00;
		ucData[3] = 0x04;
		ucData[4] = 0x24;
		ucData[5] = 0x04;
		ucData[6] = 0xCD;
		ucData[7] = 0x00;
		ucData[8] = 0xFF;
		resut = MchpUsbOtpWrite(hndl, 9, ucData,  &ActualBytesRead);
		if(resut==MCHP_Error_Success){
		}else{
		}
	}else{
		printf("\nFailed open Usb Handle\n");
	}

	/*
	* 3. Close handle to the usb device
	*/
	MchpUsbClose(hndl);
	return resut;
}