/*
**********************************************************************************
*  2014 Microchip Technology Inc. and its subsidiaries.
* You may use this software and any derivatives exclusively with
* Microchip products.
* THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS".
* NO WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE,
* INCLUDING ANY IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY,
* AND FITNESS FOR A PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP
* PRODUCTS, COMBINATION WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.
* IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
* INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
* WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
* BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE.
* TO THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL
* CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF
* FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.
* MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE
* OF THESE TERMS.
**********************************************************************************
*  USBCommonApiSample.cpp
*   This file gives the sample code/ test for common APIs to handle
*	USB device operations
*
**********************************************************************************
*  $Revision: #1 $  $DateTime: 2014/03/17 18:04:00 $  $    $
*  Description: initial version
**********************************************************************************
* $File:  
*/

#include "stdafx.h"
#include "OTPCmnXdataRamTest.h"
MCHP_USB_ERROR CommonApiSample()
{
	MCHP_USB_ERROR resut;
	HANDLE hndl = 0; 
	UCHAR  ucData[64];
	static UCHAR  ucData1[1024];
	INT ActualBytesRead=0; 
	DEVIO stDEVIO;
	
	/*
	* 1. Open handle to the connected USB2530 device 
	*/ 
	hndl = MchpUsbOpen (0x0424, 0x2530);
	if(hndl!=NULL){
		
		/*
		* 2. Use the handle for doing operation
		*/ 
		resut = MchpUsbOtpRead(hndl, 0x0, 64, ucData, &ActualBytesRead );
		if(resut==MCHP_Error_Success){
		}else{
			printf("\nFailed open Usb Handle\n");
		}
	}else{
		printf("\nFailed open Usb Handle\n");
	}

	/*
	* 3. Close handle to the usb device
	*/
	MchpUsbClose(hndl);

	//////////// MchpUsbGetDevice and MchpUsbOpenExt ///////////////
	/*
	* 1. Get the device instance path of all device
	*/ 
	resut = MchpUsbGetDevice(0x0424, 0x2530, &stDEVIO);
	if(resut==MCHP_Error_Success){

	}

	/*
	* 2. Open handle to first instance
	*/ 
	//stDEVIO is already populated from above calls
	hndl = MchpUsbOpenExt(0x00, 0, &stDEVIO);
	if(hndl!=NULL){
		/*
		* 3. Use the handle for doing operation
		*/ 
		resut = MchpUsbOtpRead(hndl, 0x0, 64, ucData, &ActualBytesRead );
		if(resut==MCHP_Error_Success){
		}else{
			printf("\nFailed open Usb Handle\n");
		}
	}else{
		printf("\nFailed open Usb Handle\n");
	}

	/*
	* 4. Free the memory allocated by the MchpUsbGetDevice for stDEVIO
	*/ 
	if(stDEVIO.dNoOfDevices){// Clear device path array
		for(int i=0; i<stDEVIO.dNoOfDevices; i++ ){
			GlobalFree(stDEVIO.DevicePath[i]);
		}
		GlobalFree(stDEVIO.DevicePath);
	}

	return resut;
}
